#include <QResource>
#include <QDir>
#include <QFile>
#include <iostream>
#include <QDebug>
#include <QDirIterator>

/////////////////////
// quick-notes how to use this (on your own risk)
// apt-get qt4-dev...
// mkdir flircc
// put this file there
// qmake -profile
// qmake
// make
/////////////////////

void
scanDirIter2 (QDir dir)
{
  QDir dest ("./");
  QDirIterator iterator (dir.absolutePath (), QDirIterator::Subdirectories);
  while (iterator.hasNext ())
    {
      iterator.next ();
      QString filename = iterator.fileName ();
      QString filepath = iterator.filePath ();
      if (!iterator.fileInfo ().isDir ())
	{
          filepath.replace (":/", "./extract/");	// important: extract dir
	  qDebug ("Dumping    %s  ", qPrintable (filepath));
	  // begin dumping
	  QFile src (iterator.filePath ());
	  src.open (QIODevice::ReadWrite);
	  src.copy (iterator.filePath (), filepath);	//it is saved (not best code)
	  src.close ();
	  //end dumping         
	}
      else if (iterator.fileInfo ().isDir ())
	{
          filepath.replace (":/", "./extract/");	// important: extract dir	  
	  qDebug ("DIR: %s ", qPrintable (filepath));
          dest.mkpath (filepath);	//ensure output dir is there
	}
      else
	{
	  qDebug ("ERROR ERROR ERROR");
	}
    }
}

////////////////////
int
main (int argc, char **argv)
{
  QString rccName ("facet_z3.rcc");
  std::cout << "Processing ";
  std::cout << rccName.toLocal8Bit ().data ();
  std::cout << "\n";
  QResource::registerResource (rccName);	//load .rcc file

  QDir rccVirtualDir (":/");
  scanDirIter2 (rccVirtualDir);

  QResource::unregisterResource (rccName);	//unload .rcc
  std::cout << "Finished";
  //std::cin.get ();
}
